local ffi = require 'ffi'

local ok, lib = pcall(ffi.load, 'libssl.so.1.0.0')
if not ok then
    lib = ffi.load('libssl.so')
end

ffi.cdef[[

unsigned char *SHA1(const unsigned char *d, size_t n, unsigned char *md);

]]

local m = {}

function m.SHA1(s)
    local raw_hash = ffi.new("uint8_t[?]", 20)
    lib.SHA1(s, #s, raw_hash)
    return ffi.string(raw_hash, 20)
end

return m
