local mt = {}

mt.defined = {}

function mt:include(args, ...)
    if type(args) ~= 'table' then
        args = {args, ...}
    end
    for i = 1, #args do
        local name = args[i]:gsub('%W', '_')
        -- This works like the usual C header file #ifdef, #define, #endif
        -- preprocessor guards, and for exactly the same reason.
        if not self.defined[name] then
            self.defined[name] = true
            require('lj_include/' .. name)
        end
    end
end

mt.__index = mt
mt.__call = mt.include

setmetatable(mt, mt)

return mt
