local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('signal')
lj_include('bits_sigcontext')

ffi.cdef[[
typedef int greg_t;
typedef greg_t gregset_t[18];
enum {
    REG_R0 = 0,
    REG_R1 = 1,
    REG_R2 = 2,
    REG_R3 = 3,
    REG_R4 = 4,
    REG_R5 = 5,
    REG_R6 = 6,
    REG_R7 = 7,
    REG_R8 = 8,
    REG_R9 = 9,
    REG_R10 = 10,
    REG_R11 = 11,
    REG_R12 = 12,
    REG_R13 = 13,
    REG_R14 = 14,
    REG_R15 = 15
};
struct _libc_fpstate {
    struct {
	unsigned int sign1:1;
	unsigned int unused:15;
	unsigned int sign2:1;
	unsigned int exponent:14;
	unsigned int j:1;
	unsigned int mantissa1:31;
	unsigned int mantissa0:32;
    } fpregs[8];
    unsigned int fpsr:32;
    unsigned int fpcr:32;
    unsigned char ftype[8];
    unsigned int init_flag;
};
typedef struct _libc_fpstate fpregset_t;
typedef struct sigcontext mcontext_t;
typedef struct ucontext {
    unsigned long uc_flags;
    struct ucontext *uc_link;
    stack_t uc_stack;
    mcontext_t uc_mcontext;
    __sigset_t uc_sigmask;
    unsigned long uc_regspace[128];
} ucontext_t;
]]

local defs = {
    NGREG = '18',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

